<template>
  <v-row no-gutters>
    <v-col cols="12">
      <general-info
        class="mb-5"
        :min-vehicles="minVehicles"
        @change="handleChangeInfoInputs"
      />

      <select-orders
        class="mb-5"
        @select="handleSelectOrders"
      />

      <v-row no-gutters justify="center">
        <v-col lg="4" xl="4" cols="12">
          <option-btns
            :register-loading="loading"
            :disable-register="orders.length === 0"
            @cancel="cancelProgram"
            @register="registerProgram"
          />
        </v-col>
      </v-row>
    </v-col>
  </v-row>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import { compose, pluck, sum } from 'ramda';
import GeneralInfo from './GeneralInfo';
import SelectOrders from './SelectOrders';
import OptionBtns from '~/components/Common/Form/OptionBtns';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'ProgramForm',
  components: {
    GeneralInfo,
    SelectOrders,
    OptionBtns,
  },
  data: () => ({
    loading: false,
    orders: [],
    departureAt: null,
  }),
  computed: {
    ...mapState({
      vehicleCapacity: state => state.config.capacity,
    }),
    minVehicles() {
      const totalUnitsToSend = compose(sum, pluck('toSendUnits'))(this.orders);
      return Math.ceil(totalUnitsToSend / this.vehicleCapacity);
    },
  },
  methods: {
    ...mapActions({
      programNewDispatch: 'programming/dispatches/programNewDispatch',
    }),
    handleChangeInfoInputs({ departureAt }) {
      this.departureAt = departureAt;
    },
    handleSelectOrders({ orders }) {
      this.orders = orders;
    },
    cancelProgram() {
      this.$router.push('/programacion/despachos');
    },
    async registerProgram() {
      const { departureAt, orders } = this;
      const orderIds = pluck('id', orders);
      try {
        this.loading = true;
        await this.programNewDispatch({ departureTime: departureAt, orderIds });
        this.$toast.success('Se ha programado el despacho correctamente', successOptions);
        await this.$router.push('/programacion/despachos');
      } catch (e) {
        this.$toast.error('No se ha podido programar el despacho', errorOptions);
      }
      this.loading = false;
    },
  },
};
</script>
